;-------------------------------------------------------------------------
.386p
CSEG segment use16
assume cs:cseg, ds:cseg, ss:cseg, es:cseg
	org	100h
start:
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
Code_selector	=  8
Stack_selector	= 16
Data_selector	= 24
Screen_selector	= 32
;--------------------------------------------------------------------------
	mov	bx,offset GDT + 8	; 
	xor	eax,eax			; 
	mov	edx,eax			; 
	push	cs
	pop	ax			; 
	shl	eax,4			; 
	mov	dx,1024			; 
	mov	cl,10011000b		; 
	call	set_descriptor		; 
	lea	dx,Stack_seg_start	; 
	add	eax,edx			; 
	mov	dx,1024			; 
	mov	cl,10010110b		; 
	call	set_descriptor		; 
	xor	eax,eax	; EAX = 0	; 
	mov	ax,ds			; 
	shl	eax,4			; 
	xor	ecx,ecx			; 
	lea	cx,PMode_data_start	; 
	add	eax,ecx			; 
	lea	dx,PMode_data_end
	sub	dx,cx		; 
	mov	cl,10010010b		; 
	call	set_descriptor	; 

	mov	eax,0b8000h		; 
	mov	edx,4000	; 
	mov	cl,10010010b		; 
	call	set_descriptor	; 
	xor	eax,eax		; 
	mov	edx,eax		; 
	mov	ax,ds
	shl	eax,4		; 
	lea	dx,GDT
	add	eax,edx	; 
	mov	GDT_adr,eax	; 

	mov	dx,39		; 
	mov	GDT_lim,dx	; 
	cli		; 
	lgdt	GDTR		; 
	mov	eax,cr0
	or	al,1
	mov	cr0,eax
	db	0eah			; 
	dw	P_Mode_entry		; 
	dw	Code_selector
;--------------------------------------------------------------------------
P_Mode_entry:
	mov	ax,Screen_selector
	mov	es,ax
	mov	ax,Data_selector
	mov	ds,ax
	mov	ax,Stack_selector
	mov	ss,ax
	mov	sp,0
	mov	bx,0	; 
	mov	di,480		; 
	call	putzs
loop_1:
	jmp	loop_1

;--------------------------------------------------------------------------
;-------------------------------------------------------------------------
set_descriptor	proc	near

	push	eax		; 
	push	ecx		; 
	push	cx		; 
	mov	cx,ax		; 
	shl	ecx,16		; 
	mov	cx,dx		; 
	mov	[ bx ],ecx	; 
	shr	eax,16		; 
	mov	cl,ah		; 
	shl	ecx,24		; 
	mov	cl,al		; 
	pop	ax		; 
	mov	ch,al		; 
	mov	[ bx + 4 ],ecx	; 
	add	bx,8		; 
	pop	ecx		; 
	pop	eax		; 
	ret

set_descriptor	endp
;-------------------------------------------------------------------------
putzs	proc	near

	push	ax
	push	bx
	push	es
	push	di
	mov	ah,1bh		; 
putzs_1:
	mov	al,[bx]		; 
	inc	bx		; 
	cmp	al,0		; 
	je	putzs_end	; 
	mov	es:[di],ax	; 
	add	di,2		; 
	jmp	putzs_1		; 
				; 
putzs_end:
	pop	di
	pop	es
	pop	bx
	pop	ax
	ret

putzs		endp
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;   GDTR:

GDTR	label	fword
GDT_lim		dw	?
GDT_adr		dd	?
;--------------------------------------------------------------------------
GDT:
	dd	?,?	; 0- 
	dd	?,?	; 1-  ()
	dd	?,?	; 2-  ()
	dd	?,?	; 3-  ()
	dd	?,?	; 4-  ()
;--------------------------------------------------------------------------
PMode_data_start:	;      .
;--------------------------------------------------------------------------
db	"I am in protected mode!!!",0	; ZS-    P-Mode.
;--------------------------------------------------------------------------
PMode_data_end:		;   .
;--------------------------------------------------------------------------
	db	1024 dup (?)	;   .
Stack_seg_start:	;    -    .
;--------------------------------------------------------------------------
	CSEG	ends
	end	start